﻿#targetengine boriskasmoscow

/**
* @@@BUILDINFO@@@ changeCase.jsx !Version 1. Sat Dec 13 2014 12:31:30 GMT+0300
www.adobeindesign.ru
*/

app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
var myDocument = app.activeDocument;
var RemoveWhiteSpace = true;

if(parseInt(app.version) >= 8)
{        
    var myWin = myDialog();
    myWin.show();
}
else
{
    alert("Sorry, for InDesign CS6+ only");
}

function myDialog()
{
    
    var myCharacterStyleNames = myGetCharacterStyleNames();
    var myDialog = new Window('palette', "removeSpaceBetweenLetters");
    this.windowRef = myDialog;
	myDialog.orientation = "column";
     myDialog.alignChildren = "center";
     
    // добавляем панель 1 с элементами управления // add panel1
    myDialog.Pnl1 = myDialog.add("panel", undefined, '');
	myDialog.Pnl1.orientation = "column";
    myDialog.Pnl1.alignChildren = "left";
    myDialog.Pnl1.dropdown = myDialog.Pnl1.add("dropdownlist", undefined, myCharacterStyleNames);
    myDialog.Pnl1.dropdown.title = 'Select Char Style'; 
    myDialog.Pnl1.dropdown.minimumSize = [250,20];
    myDialog.Pnl1.dropdown.enabled = true;
    myDialog.Pnl1.dropdown.selection = 0;
    
    // add buttons    
    var myButtonGroup = myDialog.add( "group" );
    myButtonGroup.orientation = 'row';
    myButtonGroup.startButton = myButtonGroup.add( "button", undefined, "Start" );
    myButtonGroup.startButton.enabled = true;
    myButtonGroup.startButton.helpTip = "To change case click the Start button and then select the text";
    myButtonGroup.startButton.onClick = function() 
    {  
        myCase= myDialog.Pnl1.dropdown.selection.text;
        myChStyle = getCharacterStyleByName(myCase)
        // add EventListener
        app.addEventListener("afterSelectionChanged", myChangeCharStyle);
        // Change Tool
        app.toolBoxTools.currentTool = UITools.TYPE_TOOL;
        // Change userInteractionLevel
        app.scriptPreferences.userInteractionLevel = UserInteractionLevels.NEVER_INTERACT;
        // Bootons management
        myButtonGroup.startButton.enabled = false;
        myButtonGroup.StopButton.enabled = true;
        myDialog.Pnl1.dropdown.enabled = false;
    } //onClick
    myButtonGroup.cancelButton = myButtonGroup.add( "button", undefined, "Exit" );
    myButtonGroup.cancelButton.onClick = function() 
    { 
        app.removeEventListener("afterSelectionChanged", myChangeCharStyle);
        app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
        myDialog = this.window.close( 0 ); 
    }
    // add Stop-button
    myButtonGroup.StopButton = myButtonGroup.add( "button", undefined, "Stop" );
    myButtonGroup.StopButton.enabled = false;
    myButtonGroup.StopButton.helpTip = "Put button for change parametrs";
    myButtonGroup.StopButton.onClick = function() 
    { 
        app.removeEventListener("afterSelectionChanged", myChangeCharStyle);
        app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
        myButtonGroup.startButton.enabled = true;
        myDialog.Pnl1.dropdown.enabled = true;
    }
    //myDialog.stxt = myDialog.add("statictext", undefined, "www.adobeindesign.ru");
return myDialog;
     
     
     
} // fnc

function myChangeCharStyle(e)
{
 
 switch(app.selection[0].constructor.name)      
	{      
		case "Character":      
		case "Word":      
		case "TextStyleRange":      
		case "Line":      
		case "Paragraph":      
		case "TextColumn":      
		case "Text": 
            reallyChangeCharStyle(app.selection[0]);
            removeWhiteSpace(app.selection[0]);
            break;
		default :      
            break;    
	}  
} // fnc


function reallyChangeCharStyle(myObj)
{
myObj.appliedCharacterStyle = myChStyle;
} // fnc

function removeWhiteSpace(myObj)
{
//var text3 = " a b    c d e   f g   ";
//var newText3 = text3.replace(/\s+/g, ''); 
//try { 
    myObj.contents = myObj.contents.replace(/\s+/g, ''); 
//    }
//catch(er) {}
}
function myGetCharacterStyleNames()
// Получаем список символьных стилей
{
	var curGroup;
	var curGroupName;
	var curNameInGroup;
	var myCharacterStyleNames = app.activeDocument.characterStyles.everyItem().name;
	myCharacterStyleNames.shift(); // удаление стиля None
	var charGroups = app.activeDocument.characterStyleGroups;
	var charStyleGroupLen = charGroups.length;
	for(var i=0; i < charStyleGroupLen; i++)
	{
		curGroup = charGroups[i];
		curGroupName = charGroups[i].name;
		curGroupStyleNames = curGroup.characterStyles.everyItem().name;
		for (j=0; j< curGroupStyleNames.length; j++)
		{
			curNameInGroup = curGroupName +":"+ curGroupStyleNames[j];
			myCharacterStyleNames.push(curNameInGroup);
		}
	} //for
	return myCharacterStyleNames;
} // fnc

function getCharacterStyleByName(myStyleName)
{
	var DocChStyles = app.activeDocument.characterStyles;
	var DocCharGroups = app.activeDocument.characterStyleGroups;
	// Есть ли в имени полученного символьного стиля двоеточие? (двоеточие разделяет название группы стилей и название стиля)
	myStyleName = String (myStyleName);
	var pos = myStyleName.indexOf(":")
	if(pos == -1)
	{
	// стиль не в группе
		return DocChStyles.item(myStyleName)
	} //if...
	else
	{// Стиль в какой-то группе
		var myGroupAndStyleNames = myStyleName.split(":")
		var myGroupName = myGroupAndStyleNames[0];
		var myStyleName = myGroupAndStyleNames[1];
		var myGroup = DocCharGroups.item(myGroupName);
		return myGroup.characterStyles.itemByName(myStyleName);				
	} // else
} // fnc()